#line 1 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
#line 1 "c:/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 1 "d:/arm/projects/demo/serial_flash/3 libstock example/sf_driver.h"
#line 33 "d:/arm/projects/demo/serial_flash/3 libstock example/sf_driver.h"
extern sbit CS_Serial_Flash_bit;
extern sbit CS_Serial_Flash_Direction_bit;



static const unsigned short _SERIAL_FLASH_CMD_RDID = 0x9F;
static const unsigned short _SERIAL_FLASH_CMD_READ = 0x03;
static const unsigned short _SERIAL_FLASH_CMD_WRITE = 0x02;
static const unsigned short _SERIAL_FLASH_CMD_WREN = 0x06;
static const unsigned short _SERIAL_FLASH_CMD_RDSR = 0x05;
static const unsigned short _SERIAL_FLASH_CMD_ERASE = 0xC7;
static const unsigned short _SERIAL_FLASH_CMD_EWSR = 0x06;
static const unsigned short _SERIAL_FLASH_CMD_WRSR = 0x01;
static const unsigned short _SERIAL_FLASH_CMD_SER = 0xD8;


void SerialFlash_init();
void SerialFlash_WriteEnable();
unsigned char SerialFlash_IsWriteBusy();
void SerialFlash_WriteByte(unsigned char _data, unsigned long address);
void SerialFlash_WriteWord(unsigned int _data, unsigned long address);
unsigned char SerialFlash_ReadID(void);
unsigned char SerialFlash_ReadByte(unsigned long address);
unsigned int SerialFlash_ReadWord(unsigned long address);
unsigned char SerialFlash_WriteArray(unsigned long address, unsigned char* pData, unsigned int nCount);
void SerialFlash_ReadArray(unsigned long address, unsigned char* pData, unsigned int nCount);
void SerialFlash_ChipErase(void);
void SerialFlash_ResetWriteProtection();
void SerialFlash_SectorErase(unsigned long address);
#line 33 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
sbit CS_Serial_Flash_bit at GPIO_PORTC_DATA.B7;
sbit CS_Serial_Flash_Direction_bit at GPIO_PORTC_DIR.B7;
#line 45 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
void SerialFlash_init(){
 CS_Serial_Flash_bit = 1;
 CS_Serial_Flash_Direction_bit = 1;
}
#line 57 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
void SerialFlash_WriteEnable(){
 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_WREN);
 CS_Serial_Flash_bit = 1;
}
#line 70 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
unsigned char SerialFlash_IsWriteBusy(){
 unsigned char temp;

 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_RDSR);
 temp = SPI_Rd_Ptr(0);
 CS_Serial_Flash_bit = 1;

 return (temp&0x01);
}
#line 88 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
void SerialFlash_WriteByte(unsigned char _data, unsigned long address){
 SerialFlash_WriteEnable();


 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_WRITE);
 SPI_Wr_Ptr( ((char *)&address)[2] );
 SPI_Wr_Ptr( ((char *)&address)[1] );
 SPI_Wr_Ptr( ((char *)&address)[0] );
 SPI_Wr_Ptr(_data);
 CS_Serial_Flash_bit = 1;


 while(SerialFlash_isWriteBusy());
}
#line 111 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
void SerialFlash_WriteWord(unsigned int _data, unsigned long address){
 SerialFlash_WriteByte( ((char *)&_data)[1] ,address);
 SerialFlash_WriteByte( ((char *)&_data)[0] ,address+1);
}
#line 123 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
unsigned char SerialFlash_ReadID(void){
 unsigned char temp;

 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_RDID);
 temp = SPI_Rd_Ptr(0);
 CS_Serial_Flash_bit = 1;

 return temp;
}
#line 141 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
unsigned char SerialFlash_ReadByte(unsigned long address){
 unsigned char temp;

 CS_Serial_Flash_bit = 0;

 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_READ);
 SPI_Wr_Ptr( ((char *)&address)[2] );
 SPI_Wr_Ptr( ((char *)&address)[1] );
 SPI_Wr_Ptr( ((char *)&address)[0] );
 temp = SPI_Rd_Ptr(0);

 CS_Serial_Flash_bit = 1;
 return temp;
}
#line 163 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
unsigned int SerialFlash_ReadWord(unsigned long address){
 unsigned int temp;

  ((char *)&temp)[1]  = SerialFlash_ReadByte(address);
  ((char *)&temp)[0]  = SerialFlash_ReadByte(address+1);

 return temp;
}
#line 180 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
unsigned char SerialFlash_WriteArray(unsigned long address, unsigned char* pData, unsigned int nCount){
 unsigned long addr;
 unsigned char* pD;
 unsigned int counter;

 addr = address;
 pD = pData;



 for(counter = 0; counter < nCount; counter++){
 SerialFlash_WriteByte(*pD++, addr++);
 }




 for (counter=0; counter < nCount; counter++){
 if (*pData != SerialFlash_ReadByte(address))
 return 0;
 pData++;
 address++;
 }

 return 1;
}
#line 215 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
void SerialFlash_ReadArray(unsigned long address, unsigned char* pData, unsigned int nCount){
 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_READ);
 SPI_Wr_Ptr( ((char *)&address)[2] );
 SPI_Wr_Ptr( ((char *)&address)[1] );
 SPI_Wr_Ptr( ((char *)&address)[0] );

 while(nCount--){
 *pData++ = SPI_Rd_Ptr(0);
 }
 CS_Serial_Flash_bit = 1;
}
#line 235 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
void SerialFlash_ChipErase(void){

 SerialFlash_WriteEnable();

 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_ERASE);
 CS_Serial_Flash_bit = 1;


 while(SerialFlash_IsWriteBusy());
}
#line 254 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
void SerialFlash_ResetWriteProtection(){

 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_EWSR);
 CS_Serial_Flash_bit = 1;

 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_EWSR);
 SPI_Wr_Ptr(0);
 CS_Serial_Flash_bit = 1;
}
#line 273 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/SF_driver.c"
void SerialFlash_SectorErase(unsigned long address){

 SerialFlash_WriteEnable();

 CS_Serial_Flash_bit = 0;
 SPI_Wr_Ptr(_SERIAL_FLASH_CMD_SER);
 SPI_Wr_Ptr( ((char *)&address)[2] );
 SPI_Wr_Ptr( ((char *)&address)[1] );
 SPI_Wr_Ptr( ((char *)&address)[0] );
 CS_Serial_Flash_bit = 1;


 while(SerialFlash_IsWriteBusy());
}
