// EasyMX PRO v7 For Stellaris ARM

#include "Soft_UART_Helper.h"
#include "Serial_Flash_Util.h"
#include "SF_driver.h"
#include "colored_squares_resources.h"

// tft must be initialized if you want text output to work
// if not, you can just comment tft code

/*
// you need these libs:
C_String
C_Type
Software_UART
SPI
Sprintf
TFT
*/

/*
For configuration of TFT, UART and Serial Flash see manual provided by Mikroelektronika
for your board.
*/

// TFT module connections
char TFT_DataPort at GPIO_PORTJ_DATA;
sbit TFT_RST at GPIO_PORTH_DATA.B5;
sbit TFT_BLED at GPIO_PORTA_DATA.B3;
sbit TFT_RS at GPIO_PORTG_DATA.B7;
sbit TFT_CS at GPIO_PORTH_DATA.B6;
sbit TFT_RD at GPIO_PORTC_DATA.B5;
sbit TFT_WR at GPIO_PORTH_DATA.B4;
char TFT_DataPort_Direction at GPIO_PORTJ_DIR;
sbit TFT_RST_Direction at GPIO_PORTH_DIR.B5;
sbit TFT_BLED_Direction at GPIO_PORTA_DIR.B3;
sbit TFT_RS_Direction at GPIO_PORTG_DIR.B7;
sbit TFT_CS_Direction at GPIO_PORTH_DIR.B6;
sbit TFT_RD_Direction at GPIO_PORTC_DIR.B5;
sbit TFT_WR_Direction at GPIO_PORTH_DIR.B4;
// End TFT module connections

void InitMCU(){
// SPI config
  char status = 0;
  status = GPIO_Config(&GPIO_PORTC_DATA_BITS, _GPIO_PINMASK_7, _GPIO_DIR_OUTPUT, _GPIO_CFG_DIGITAL_ENABLE, 0);
  if (status == 1) Soft_UART_WriteText("GPIO error");
}

void main() {
  Init_Soft_UART();
  
  InitMCU();
  
  SPI0_Init_Advanced(10000000, _SPI_MASTER, _SPI_8_BIT, &_GPIO_MODULE_SPI0_A245);
  SerialFlash_init();
  SerialFlash_WriteEnable();
  
  CopyImageToSerialFlash(red_square_bmp, 3206, 1); // setting thrid parameter to 1 erases the chip
  TFT_Set_Ext_Buffer(FlashReadHandler); // set function to read external memory
  // display image
  // note: Function will be called to read first 10 bytes, but it will read only 6 for 24-bit color images
  // note: Function will be called for every row the picture has
  TFT_Ext_Image(200, 150, 0x00000000, 1); // display image
}