#line 1 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/Serial_Flash_Util.c"
#line 1 "d:/arm/projects/demo/serial_flash/3 libstock example/sf_driver.h"
#line 33 "d:/arm/projects/demo/serial_flash/3 libstock example/sf_driver.h"
extern sbit CS_Serial_Flash_bit;
extern sbit CS_Serial_Flash_Direction_bit;



static const unsigned short _SERIAL_FLASH_CMD_RDID = 0x9F;
static const unsigned short _SERIAL_FLASH_CMD_READ = 0x03;
static const unsigned short _SERIAL_FLASH_CMD_WRITE = 0x02;
static const unsigned short _SERIAL_FLASH_CMD_WREN = 0x06;
static const unsigned short _SERIAL_FLASH_CMD_RDSR = 0x05;
static const unsigned short _SERIAL_FLASH_CMD_ERASE = 0xC7;
static const unsigned short _SERIAL_FLASH_CMD_EWSR = 0x06;
static const unsigned short _SERIAL_FLASH_CMD_WRSR = 0x01;
static const unsigned short _SERIAL_FLASH_CMD_SER = 0xD8;


void SerialFlash_init();
void SerialFlash_WriteEnable();
unsigned char SerialFlash_IsWriteBusy();
void SerialFlash_WriteByte(unsigned char _data, unsigned long address);
void SerialFlash_WriteWord(unsigned int _data, unsigned long address);
unsigned char SerialFlash_ReadID(void);
unsigned char SerialFlash_ReadByte(unsigned long address);
unsigned int SerialFlash_ReadWord(unsigned long address);
unsigned char SerialFlash_WriteArray(unsigned long address, unsigned char* pData, unsigned int nCount);
void SerialFlash_ReadArray(unsigned long address, unsigned char* pData, unsigned int nCount);
void SerialFlash_ChipErase(void);
void SerialFlash_ResetWriteProtection();
void SerialFlash_SectorErase(unsigned long address);
#line 1 "d:/arm/projects/demo/serial_flash/3 libstock example/serial_flash_util.h"




void SerialFlashUtilInit();



unsigned long CopyImageToSerialFlash(const code char *image, unsigned int image_length, char erase_chip);


char* FlashReadHandler(unsigned long offset, unsigned long count, unsigned long* num);
#line 1 "d:/arm/projects/demo/serial_flash/3 libstock example/soft_uart_helper.h"



void Init_Soft_UART();
void Soft_UART_WriteText(char *string);
#line 13 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/Serial_Flash_Util.c"
static unsigned char g_buffer[ 64 ] = { 0 };
static unsigned char serial_buffer[ 512 ] = { 0 };
static unsigned int g_row = 0;
static unsigned int g_col = 5;
static unsigned int g_incr = 15;


void SerialFlashUtilInit()
{
 g_row = 5;
 g_col = 5;

}





unsigned long CopyImageToSerialFlash(const code char *image, unsigned int image_length, char erase_chip)
{
 unsigned long flash_addr = 0x0000;
 unsigned long image_flash_address = flash_addr;
 unsigned int i = 0;
 char* image_ptr = image;

 if (image == 0) { return 0; }

 if (erase_chip == 1)
 {
 TFT_Write_Text("Erasing chip... ", g_col, g_row+=g_incr);
 SerialFlash_ChipErase();
 TFT_Write_Text("Done", g_col, g_row+=g_incr);
 }

 TFT_Write_Text("Copying image to serial flash...", g_col, g_row+=g_incr);
 for (i = 0; i < image_length; i++)
 {


 SerialFlash_WriteByte(*image_ptr, flash_addr);
 image_ptr++;
 flash_addr++;
 }
 TFT_Write_Text("Done", g_col, g_row+=g_incr);


 TFT_Write_Text("Verifying...", g_col, g_row+=g_incr);
 image_ptr = image;
 flash_addr = 0x0000;
 for (i = 0; i < image_length; i++)
 {
 if (*image_ptr != SerialFlash_ReadByte(flash_addr))
 {
 TFT_Write_Text("ERROR", g_col, g_row+=g_incr);
 return 0;
 }
 image_ptr++;
 flash_addr++;
 }
 TFT_Write_Text("Done", g_col, g_row+=g_incr);

 return image_flash_address;
}




char* FlashReadHandler(unsigned long offset, unsigned long count, unsigned long* num)
{
 const unsigned long flash_addr = 0x00000000;

 int i = 0;

 if (count >  512 ) Soft_UART_WriteText("error: buffer overflow");
#line 101 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/Serial_Flash_Util.c"
 memset(serial_buffer, 0,  512 );
 SerialFlash_ReadArray(offset, serial_buffer, count);
 *num = count;
#line 111 "D:/ARM/Projects/Demo/Serial_Flash/3 libstock example/Serial_Flash_Util.c"
 return serial_buffer;
}
